// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef AMBA_APB_BUS_HH
#define AMBA_APB_BUS_HH

#include <cstddef>
#include <stdint.h>

class amba_apb_bus
{

public:

    uint32_t apb_8_prdata_old;
    bool apb_8_pready_old;
    uint32_t apb_7_prdata_old;
    bool apb_7_pready_old;
    uint32_t apb_6_prdata_old;
    bool apb_6_pready_old;
    uint32_t apb_5_prdata_old;
    bool apb_5_pready_old;
    uint32_t apb_4_prdata_old;
    bool apb_4_pready_old;
    uint32_t apb_3_prdata_old;
    bool apb_3_pready_old;
    uint32_t apb_2_prdata_old;
    bool apb_2_pready_old;
    uint32_t apb_1_prdata_old;
    bool apb_1_pready_old;
    uint32_t apb_master_pwdata_old;
    bool apb_master_pwrite_old;
    bool apb_master_penable_old;
    bool apb_master_psel8_old;
    bool apb_master_psel7_old;
    bool apb_master_psel6_old;
    bool apb_master_psel5_old;
    bool apb_master_psel4_old;
    bool apb_master_psel3_old;
    bool apb_master_psel2_old;
    bool apb_master_psel1_old;
    uint32_t apb_master_paddr_old;
    bool apb_master_presetn_old;
    bool clk_old;
    struct amba_apb_bus_iostruct{
        bool * clk;
        bool * apb_master_pclk;
        bool * apb_master_presetn;
        uint32_t * apb_master_paddr;
        bool * apb_master_psel1;
        bool * apb_master_psel2;
        bool * apb_master_psel3;
        bool * apb_master_psel4;
        bool * apb_master_psel5;
        bool * apb_master_psel6;
        bool * apb_master_psel7;
        bool * apb_master_psel8;
        bool * apb_master_penable;
        bool * apb_master_pwrite;
        uint32_t * apb_master_pwdata;
        bool * apb_master_pready;
        uint32_t * apb_master_prdata;
        bool * apb_1_pclk;
        bool * apb_1_presetn;
        uint32_t * apb_1_paddr;
        bool * apb_1_psel;
        bool * apb_1_penable;
        bool * apb_1_pwrite;
        uint32_t * apb_1_pwdata;
        bool * apb_1_pready;
        uint32_t * apb_1_prdata;
        bool * apb_2_pclk;
        bool * apb_2_presetn;
        uint32_t * apb_2_paddr;
        bool * apb_2_psel;
        bool * apb_2_penable;
        bool * apb_2_pwrite;
        uint32_t * apb_2_pwdata;
        bool * apb_2_pready;
        uint32_t * apb_2_prdata;
        bool * apb_3_pclk;
        bool * apb_3_presetn;
        uint32_t * apb_3_paddr;
        bool * apb_3_psel;
        bool * apb_3_penable;
        bool * apb_3_pwrite;
        uint32_t * apb_3_pwdata;
        bool * apb_3_pready;
        uint32_t * apb_3_prdata;
        bool * apb_4_pclk;
        bool * apb_4_presetn;
        uint32_t * apb_4_paddr;
        bool * apb_4_psel;
        bool * apb_4_penable;
        bool * apb_4_pwrite;
        uint32_t * apb_4_pwdata;
        bool * apb_4_pready;
        uint32_t * apb_4_prdata;
        bool * apb_5_pclk;
        bool * apb_5_presetn;
        uint32_t * apb_5_paddr;
        bool * apb_5_psel;
        bool * apb_5_penable;
        bool * apb_5_pwrite;
        uint32_t * apb_5_pwdata;
        bool * apb_5_pready;
        uint32_t * apb_5_prdata;
        bool * apb_6_pclk;
        bool * apb_6_presetn;
        uint32_t * apb_6_paddr;
        bool * apb_6_psel;
        bool * apb_6_penable;
        bool * apb_6_pwrite;
        uint32_t * apb_6_pwdata;
        bool * apb_6_pready;
        uint32_t * apb_6_prdata;
        bool * apb_7_pclk;
        bool * apb_7_presetn;
        uint32_t * apb_7_paddr;
        bool * apb_7_psel;
        bool * apb_7_penable;
        bool * apb_7_pwrite;
        uint32_t * apb_7_pwdata;
        bool * apb_7_pready;
        uint32_t * apb_7_prdata;
        bool * apb_8_pclk;
        bool * apb_8_presetn;
        uint32_t * apb_8_paddr;
        bool * apb_8_psel;
        bool * apb_8_penable;
        bool * apb_8_pwrite;
        uint32_t * apb_8_pwdata;
        bool * apb_8_pready;
        uint32_t * apb_8_prdata;

        amba_apb_bus_iostruct():
            clk(nullptr),
            apb_master_pclk(nullptr),
            apb_master_presetn(nullptr),
            apb_master_paddr(nullptr),
            apb_master_psel1(nullptr),
            apb_master_psel2(nullptr),
            apb_master_psel3(nullptr),
            apb_master_psel4(nullptr),
            apb_master_psel5(nullptr),
            apb_master_psel6(nullptr),
            apb_master_psel7(nullptr),
            apb_master_psel8(nullptr),
            apb_master_penable(nullptr),
            apb_master_pwrite(nullptr),
            apb_master_pwdata(nullptr),
            apb_master_pready(nullptr),
            apb_master_prdata(nullptr),
            apb_1_pclk(nullptr),
            apb_1_presetn(nullptr),
            apb_1_paddr(nullptr),
            apb_1_psel(nullptr),
            apb_1_penable(nullptr),
            apb_1_pwrite(nullptr),
            apb_1_pwdata(nullptr),
            apb_1_pready(nullptr),
            apb_1_prdata(nullptr),
            apb_2_pclk(nullptr),
            apb_2_presetn(nullptr),
            apb_2_paddr(nullptr),
            apb_2_psel(nullptr),
            apb_2_penable(nullptr),
            apb_2_pwrite(nullptr),
            apb_2_pwdata(nullptr),
            apb_2_pready(nullptr),
            apb_2_prdata(nullptr),
            apb_3_pclk(nullptr),
            apb_3_presetn(nullptr),
            apb_3_paddr(nullptr),
            apb_3_psel(nullptr),
            apb_3_penable(nullptr),
            apb_3_pwrite(nullptr),
            apb_3_pwdata(nullptr),
            apb_3_pready(nullptr),
            apb_3_prdata(nullptr),
            apb_4_pclk(nullptr),
            apb_4_presetn(nullptr),
            apb_4_paddr(nullptr),
            apb_4_psel(nullptr),
            apb_4_penable(nullptr),
            apb_4_pwrite(nullptr),
            apb_4_pwdata(nullptr),
            apb_4_pready(nullptr),
            apb_4_prdata(nullptr),
            apb_5_pclk(nullptr),
            apb_5_presetn(nullptr),
            apb_5_paddr(nullptr),
            apb_5_psel(nullptr),
            apb_5_penable(nullptr),
            apb_5_pwrite(nullptr),
            apb_5_pwdata(nullptr),
            apb_5_pready(nullptr),
            apb_5_prdata(nullptr),
            apb_6_pclk(nullptr),
            apb_6_presetn(nullptr),
            apb_6_paddr(nullptr),
            apb_6_psel(nullptr),
            apb_6_penable(nullptr),
            apb_6_pwrite(nullptr),
            apb_6_pwdata(nullptr),
            apb_6_pready(nullptr),
            apb_6_prdata(nullptr),
            apb_7_pclk(nullptr),
            apb_7_presetn(nullptr),
            apb_7_paddr(nullptr),
            apb_7_psel(nullptr),
            apb_7_penable(nullptr),
            apb_7_pwrite(nullptr),
            apb_7_pwdata(nullptr),
            apb_7_pready(nullptr),
            apb_7_prdata(nullptr),
            apb_8_pclk(nullptr),
            apb_8_presetn(nullptr),
            apb_8_paddr(nullptr),
            apb_8_psel(nullptr),
            apb_8_penable(nullptr),
            apb_8_pwrite(nullptr),
            apb_8_pwdata(nullptr),
            apb_8_pready(nullptr),
            apb_8_prdata(nullptr)
        {}

        amba_apb_bus_iostruct( bool * clk_0, bool * apb_master_pclk_0, bool * apb_master_presetn_0,
             uint32_t * apb_master_paddr_0, bool * apb_master_psel1_0, bool * apb_master_psel2_0,
             bool * apb_master_psel3_0, bool * apb_master_psel4_0, bool * apb_master_psel5_0,
             bool * apb_master_psel6_0, bool * apb_master_psel7_0, bool * apb_master_psel8_0,
             bool * apb_master_penable_0, bool * apb_master_pwrite_0, uint32_t *
             apb_master_pwdata_0, bool * apb_master_pready_0, uint32_t * apb_master_prdata_0,
             bool * apb_1_pclk_0, bool * apb_1_presetn_0, uint32_t * apb_1_paddr_0,
             bool * apb_1_psel_0, bool * apb_1_penable_0, bool * apb_1_pwrite_0,
             uint32_t * apb_1_pwdata_0, bool * apb_1_pready_0, uint32_t * apb_1_prdata_0,
             bool * apb_2_pclk_0, bool * apb_2_presetn_0, uint32_t * apb_2_paddr_0,
             bool * apb_2_psel_0, bool * apb_2_penable_0, bool * apb_2_pwrite_0,
             uint32_t * apb_2_pwdata_0, bool * apb_2_pready_0, uint32_t * apb_2_prdata_0,
             bool * apb_3_pclk_0, bool * apb_3_presetn_0, uint32_t * apb_3_paddr_0,
             bool * apb_3_psel_0, bool * apb_3_penable_0, bool * apb_3_pwrite_0,
             uint32_t * apb_3_pwdata_0, bool * apb_3_pready_0, uint32_t * apb_3_prdata_0,
             bool * apb_4_pclk_0, bool * apb_4_presetn_0, uint32_t * apb_4_paddr_0,
             bool * apb_4_psel_0, bool * apb_4_penable_0, bool * apb_4_pwrite_0,
             uint32_t * apb_4_pwdata_0, bool * apb_4_pready_0, uint32_t * apb_4_prdata_0,
             bool * apb_5_pclk_0, bool * apb_5_presetn_0, uint32_t * apb_5_paddr_0,
             bool * apb_5_psel_0, bool * apb_5_penable_0, bool * apb_5_pwrite_0,
             uint32_t * apb_5_pwdata_0, bool * apb_5_pready_0, uint32_t * apb_5_prdata_0,
             bool * apb_6_pclk_0, bool * apb_6_presetn_0, uint32_t * apb_6_paddr_0,
             bool * apb_6_psel_0, bool * apb_6_penable_0, bool * apb_6_pwrite_0,
             uint32_t * apb_6_pwdata_0, bool * apb_6_pready_0, uint32_t * apb_6_prdata_0,
             bool * apb_7_pclk_0, bool * apb_7_presetn_0, uint32_t * apb_7_paddr_0,
             bool * apb_7_psel_0, bool * apb_7_penable_0, bool * apb_7_pwrite_0,
             uint32_t * apb_7_pwdata_0, bool * apb_7_pready_0, uint32_t * apb_7_prdata_0,
             bool * apb_8_pclk_0, bool * apb_8_presetn_0, uint32_t * apb_8_paddr_0,
             bool * apb_8_psel_0, bool * apb_8_penable_0, bool * apb_8_pwrite_0,
             uint32_t * apb_8_pwdata_0, bool * apb_8_pready_0, uint32_t * apb_8_prdata_0
             ):
            clk(clk_0),
            apb_master_pclk(apb_master_pclk_0),
            apb_master_presetn(apb_master_presetn_0),
            apb_master_paddr(apb_master_paddr_0),
            apb_master_psel1(apb_master_psel1_0),
            apb_master_psel2(apb_master_psel2_0),
            apb_master_psel3(apb_master_psel3_0),
            apb_master_psel4(apb_master_psel4_0),
            apb_master_psel5(apb_master_psel5_0),
            apb_master_psel6(apb_master_psel6_0),
            apb_master_psel7(apb_master_psel7_0),
            apb_master_psel8(apb_master_psel8_0),
            apb_master_penable(apb_master_penable_0),
            apb_master_pwrite(apb_master_pwrite_0),
            apb_master_pwdata(apb_master_pwdata_0),
            apb_master_pready(apb_master_pready_0),
            apb_master_prdata(apb_master_prdata_0),
            apb_1_pclk(apb_1_pclk_0),
            apb_1_presetn(apb_1_presetn_0),
            apb_1_paddr(apb_1_paddr_0),
            apb_1_psel(apb_1_psel_0),
            apb_1_penable(apb_1_penable_0),
            apb_1_pwrite(apb_1_pwrite_0),
            apb_1_pwdata(apb_1_pwdata_0),
            apb_1_pready(apb_1_pready_0),
            apb_1_prdata(apb_1_prdata_0),
            apb_2_pclk(apb_2_pclk_0),
            apb_2_presetn(apb_2_presetn_0),
            apb_2_paddr(apb_2_paddr_0),
            apb_2_psel(apb_2_psel_0),
            apb_2_penable(apb_2_penable_0),
            apb_2_pwrite(apb_2_pwrite_0),
            apb_2_pwdata(apb_2_pwdata_0),
            apb_2_pready(apb_2_pready_0),
            apb_2_prdata(apb_2_prdata_0),
            apb_3_pclk(apb_3_pclk_0),
            apb_3_presetn(apb_3_presetn_0),
            apb_3_paddr(apb_3_paddr_0),
            apb_3_psel(apb_3_psel_0),
            apb_3_penable(apb_3_penable_0),
            apb_3_pwrite(apb_3_pwrite_0),
            apb_3_pwdata(apb_3_pwdata_0),
            apb_3_pready(apb_3_pready_0),
            apb_3_prdata(apb_3_prdata_0),
            apb_4_pclk(apb_4_pclk_0),
            apb_4_presetn(apb_4_presetn_0),
            apb_4_paddr(apb_4_paddr_0),
            apb_4_psel(apb_4_psel_0),
            apb_4_penable(apb_4_penable_0),
            apb_4_pwrite(apb_4_pwrite_0),
            apb_4_pwdata(apb_4_pwdata_0),
            apb_4_pready(apb_4_pready_0),
            apb_4_prdata(apb_4_prdata_0),
            apb_5_pclk(apb_5_pclk_0),
            apb_5_presetn(apb_5_presetn_0),
            apb_5_paddr(apb_5_paddr_0),
            apb_5_psel(apb_5_psel_0),
            apb_5_penable(apb_5_penable_0),
            apb_5_pwrite(apb_5_pwrite_0),
            apb_5_pwdata(apb_5_pwdata_0),
            apb_5_pready(apb_5_pready_0),
            apb_5_prdata(apb_5_prdata_0),
            apb_6_pclk(apb_6_pclk_0),
            apb_6_presetn(apb_6_presetn_0),
            apb_6_paddr(apb_6_paddr_0),
            apb_6_psel(apb_6_psel_0),
            apb_6_penable(apb_6_penable_0),
            apb_6_pwrite(apb_6_pwrite_0),
            apb_6_pwdata(apb_6_pwdata_0),
            apb_6_pready(apb_6_pready_0),
            apb_6_prdata(apb_6_prdata_0),
            apb_7_pclk(apb_7_pclk_0),
            apb_7_presetn(apb_7_presetn_0),
            apb_7_paddr(apb_7_paddr_0),
            apb_7_psel(apb_7_psel_0),
            apb_7_penable(apb_7_penable_0),
            apb_7_pwrite(apb_7_pwrite_0),
            apb_7_pwdata(apb_7_pwdata_0),
            apb_7_pready(apb_7_pready_0),
            apb_7_prdata(apb_7_prdata_0),
            apb_8_pclk(apb_8_pclk_0),
            apb_8_presetn(apb_8_presetn_0),
            apb_8_paddr(apb_8_paddr_0),
            apb_8_psel(apb_8_psel_0),
            apb_8_penable(apb_8_penable_0),
            apb_8_pwrite(apb_8_pwrite_0),
            apb_8_pwdata(apb_8_pwdata_0),
            apb_8_pready(apb_8_pready_0),
            apb_8_prdata(apb_8_prdata_0)
        {}

        ~amba_apb_bus_iostruct()
        {}

        bool operator == (const amba_apb_bus_iostruct & other) const
        {
            if (clk != other.clk) return false;
            if (apb_master_pclk != other.apb_master_pclk) return false;
            if (apb_master_presetn != other.apb_master_presetn) return false;
            if (apb_master_paddr != other.apb_master_paddr) return false;
            if (apb_master_psel1 != other.apb_master_psel1) return false;
            if (apb_master_psel2 != other.apb_master_psel2) return false;
            if (apb_master_psel3 != other.apb_master_psel3) return false;
            if (apb_master_psel4 != other.apb_master_psel4) return false;
            if (apb_master_psel5 != other.apb_master_psel5) return false;
            if (apb_master_psel6 != other.apb_master_psel6) return false;
            if (apb_master_psel7 != other.apb_master_psel7) return false;
            if (apb_master_psel8 != other.apb_master_psel8) return false;
            if (apb_master_penable != other.apb_master_penable) return false;
            if (apb_master_pwrite != other.apb_master_pwrite) return false;
            if (apb_master_pwdata != other.apb_master_pwdata) return false;
            if (apb_master_pready != other.apb_master_pready) return false;
            if (apb_master_prdata != other.apb_master_prdata) return false;
            if (apb_1_pclk != other.apb_1_pclk) return false;
            if (apb_1_presetn != other.apb_1_presetn) return false;
            if (apb_1_paddr != other.apb_1_paddr) return false;
            if (apb_1_psel != other.apb_1_psel) return false;
            if (apb_1_penable != other.apb_1_penable) return false;
            if (apb_1_pwrite != other.apb_1_pwrite) return false;
            if (apb_1_pwdata != other.apb_1_pwdata) return false;
            if (apb_1_pready != other.apb_1_pready) return false;
            if (apb_1_prdata != other.apb_1_prdata) return false;
            if (apb_2_pclk != other.apb_2_pclk) return false;
            if (apb_2_presetn != other.apb_2_presetn) return false;
            if (apb_2_paddr != other.apb_2_paddr) return false;
            if (apb_2_psel != other.apb_2_psel) return false;
            if (apb_2_penable != other.apb_2_penable) return false;
            if (apb_2_pwrite != other.apb_2_pwrite) return false;
            if (apb_2_pwdata != other.apb_2_pwdata) return false;
            if (apb_2_pready != other.apb_2_pready) return false;
            if (apb_2_prdata != other.apb_2_prdata) return false;
            if (apb_3_pclk != other.apb_3_pclk) return false;
            if (apb_3_presetn != other.apb_3_presetn) return false;
            if (apb_3_paddr != other.apb_3_paddr) return false;
            if (apb_3_psel != other.apb_3_psel) return false;
            if (apb_3_penable != other.apb_3_penable) return false;
            if (apb_3_pwrite != other.apb_3_pwrite) return false;
            if (apb_3_pwdata != other.apb_3_pwdata) return false;
            if (apb_3_pready != other.apb_3_pready) return false;
            if (apb_3_prdata != other.apb_3_prdata) return false;
            if (apb_4_pclk != other.apb_4_pclk) return false;
            if (apb_4_presetn != other.apb_4_presetn) return false;
            if (apb_4_paddr != other.apb_4_paddr) return false;
            if (apb_4_psel != other.apb_4_psel) return false;
            if (apb_4_penable != other.apb_4_penable) return false;
            if (apb_4_pwrite != other.apb_4_pwrite) return false;
            if (apb_4_pwdata != other.apb_4_pwdata) return false;
            if (apb_4_pready != other.apb_4_pready) return false;
            if (apb_4_prdata != other.apb_4_prdata) return false;
            if (apb_5_pclk != other.apb_5_pclk) return false;
            if (apb_5_presetn != other.apb_5_presetn) return false;
            if (apb_5_paddr != other.apb_5_paddr) return false;
            if (apb_5_psel != other.apb_5_psel) return false;
            if (apb_5_penable != other.apb_5_penable) return false;
            if (apb_5_pwrite != other.apb_5_pwrite) return false;
            if (apb_5_pwdata != other.apb_5_pwdata) return false;
            if (apb_5_pready != other.apb_5_pready) return false;
            if (apb_5_prdata != other.apb_5_prdata) return false;
            if (apb_6_pclk != other.apb_6_pclk) return false;
            if (apb_6_presetn != other.apb_6_presetn) return false;
            if (apb_6_paddr != other.apb_6_paddr) return false;
            if (apb_6_psel != other.apb_6_psel) return false;
            if (apb_6_penable != other.apb_6_penable) return false;
            if (apb_6_pwrite != other.apb_6_pwrite) return false;
            if (apb_6_pwdata != other.apb_6_pwdata) return false;
            if (apb_6_pready != other.apb_6_pready) return false;
            if (apb_6_prdata != other.apb_6_prdata) return false;
            if (apb_7_pclk != other.apb_7_pclk) return false;
            if (apb_7_presetn != other.apb_7_presetn) return false;
            if (apb_7_paddr != other.apb_7_paddr) return false;
            if (apb_7_psel != other.apb_7_psel) return false;
            if (apb_7_penable != other.apb_7_penable) return false;
            if (apb_7_pwrite != other.apb_7_pwrite) return false;
            if (apb_7_pwdata != other.apb_7_pwdata) return false;
            if (apb_7_pready != other.apb_7_pready) return false;
            if (apb_7_prdata != other.apb_7_prdata) return false;
            if (apb_8_pclk != other.apb_8_pclk) return false;
            if (apb_8_presetn != other.apb_8_presetn) return false;
            if (apb_8_paddr != other.apb_8_paddr) return false;
            if (apb_8_psel != other.apb_8_psel) return false;
            if (apb_8_penable != other.apb_8_penable) return false;
            if (apb_8_pwrite != other.apb_8_pwrite) return false;
            if (apb_8_pwdata != other.apb_8_pwdata) return false;
            if (apb_8_pready != other.apb_8_pready) return false;
            if (apb_8_prdata != other.apb_8_prdata) return false;
            return true;
        }
    };
    amba_apb_bus_iostruct hif_a2t_data;
    bool clkSuphif_0;
    amba_apb_bus();


    ~amba_apb_bus();


    bool clkSuphif_0_new;
    bool process_in_queue;
    bool flag_vhdl_process_UpdclkSuphif_0_executed;
    bool flag_clk;

    void vhdl_process_UpdclkSuphif_0();


    void update_input_queue( bool synch_phase = true );


    void update_event_queue();


    void flag_elaboration();


    void start_of_simulation();


    void initialize();


private:

    amba_apb_bus( const amba_apb_bus & );
    const amba_apb_bus& operator= ( const amba_apb_bus & );


};


#endif

